/*
 *  Copyright (c) 2018 univento.eu - All rights reserved
 * You are not allowed to use, distribute or modify this code
 */

package eu.univento.lobby;

import eu.univento.commons.server.ServerType;
import eu.univento.core.api.server.ServerSettings;
import eu.univento.lobby.commands.Setloc;
import eu.univento.lobby.listeners.*;
import lombok.Getter;
import org.bukkit.Bukkit;
import org.bukkit.Difficulty;
import org.bukkit.GameMode;
import org.bukkit.World;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * main class...
 * @author joethei
 * @version 1.0
 */
public class Lobby extends JavaPlugin{

	@Getter private static Lobby instance;

	@Override
	public void onEnable() {
		instance = this;
		PluginManager pm = Bukkit.getPluginManager();
		pm.registerEvents(new Jumppads(), this);
		pm.registerEvents(new JoinQuit(), this);
		pm.registerEvents(new Events(), this);
		pm.registerEvents(new PlayerHider(), this);
		pm.registerEvents(new ItemEvents(), this);
		pm.registerEvents(new Parkour(), this);
        pm.registerEvents(new PlayerInteract(), this);
        pm.registerEvents(new FunStuff(), this);
        //pm.registerEvents(new MenuEvents(), this);

		new Setloc(this, "setloc", "Setzt Teleport Punkte");

		if(ServerSettings.isDebug()) System.out.println("Befehle registriert");

		for(World w : Bukkit.getWorlds()) w.setDifficulty(Difficulty.PEACEFUL);

		ServerSettings.setup(ServerType.LOBBY, GameMode.ADVENTURE);
		System.out.println(" Plugin ver." + getDescription().getVersion() + " gestartet");
	}
	
	@Override
	public void onDisable() {
		System.out.println("Plugin beendet");
	}

}